﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace OASystem.Domain.Dtos.Financial
{
    /// <summary>
    /// 日付申请 dto
    /// </summary>
    public class DailyFeePaymentDto
    {}

    /// <summary>
    /// 日付申请 分页 dto
    /// </summary>
    public class PageDailyFeePaymentDto : DtoBase
    {
        /// <summary>
        /// 费用所属公司
        /// -1 全部/未选择
        /// 其他Id 公司Id
        /// </summary>
        public int CompanyId { get; set; }
        /// <summary>
        /// 财务审核状态
        /// -1 全部/未选择
        /// 0  未审核
        /// 1  已审核
        /// 2  审核未通过
        /// </summary>
        public int FinancialAuditStatus { get; set; }

        /// <summary>
        /// 总经理审核状态
        /// -1 全部/未选择
        /// 0  未审核
        /// 1  已审核
        /// 2  审核未通过
        /// </summary>
        public int ManagerAuditStatus { get; set; }

        /// <summary>
        /// 费用类型 
        /// -1 全部/未选择
        /// 其他Id 费用类型Id
        /// </summary>
        public int FeeTypeId { get; set; }

        /// <summary>
        /// 费用子类
        /// -1 全部/未选择
        /// 其他Id 费用子类Id
        /// </summary>
        public int FeeSubTypeId { get; set; }

        /// <summary>
        /// 费用说明
        /// </summary>
        public string? FeeDesc { get; set; }

        /// <summary>
        /// 申请人Id
        /// -1 全部/未选择
        /// 其他Id 员工Id
        /// </summary>
        public int CreateUserId { get; set; }
    }
}
